#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>

# This file contains functions to be used by most or all
# shell scripts in the /etc/init.d directory.
# The original part of function.inc "may" have been taken by other script
# 1.0.0 by AGX
# 1.3.0 by AGX
# 1.6.0 by by AGX at 25/10/1999



# -----------------------------------------------------------
# -------------------- Color  Utility -----------------------
# -----------------------------------------------------------
# This part is copyrighted under GPL license by
# Antonio GALLO <agx@linux.it> Made in 1999

color() {
   if [ "$TERM" = "linux" -o "$TERM" = "xterm"  ]; then

    case "$1" in
	GREEN|green)
	    echo -n -e "\033[1;32m"
    	    ;;
	CYAN|cyan) 
	    echo -n -e "\033[1;36m"
	    ;;	
        RED|red)
	    echo -n -e "\033[1;31m"
	    ;;	
	YELLOW|yellow)
	    echo -n -e "\033[1;33m"
	    ;;
	WHITE|white)
	    #echo -n -e "\033[0;37m"
	    echo -n -e "\033[37m"
	    ;;	
	BLACK|black)
	    #echo -n -e "\033[0;30m"
	    echo -n -e "\033[30m"
	    ;;
	BLUE|blue)
	    echo -n -e "\033[1;34m"
	    ;;	
	GREY|grey)
	    echo -n -e "\033[1;30m"
	    ;;
	PURPLE|purple)
	    echo -n -e "\033[1;35m"
	    ;;
    esac
  fi
}



echoc() {

  if [ "$TERM" = "linux" -o "$TERM" = "xterm" ]; then

    # Default Color is white
    DEFAULT_COLOR="\033[0;37m"

    case "$1" in
	GREEN|green)
	    echo -n -e "\033[1;32m"
    	    ;;
	CYAN|cyan) 
	    echo -n -e "\033[1;36m"
	    ;;	
        RED|red)
	    echo -n -e "\033[1;31m"
	    ;;	
	YELLOW|yellow)
	    echo -n -e "\033[1;33m"
	    ;;
	WHITE|white)
	    #echo -n -e "\033[0;37m"
	    echo -n -e "\033[37m"
	    ;;	
	BLACK|black)
	    #echo -n -e "\033[0;30m"
	    echo -n -e "\033[30m"
	    ;;
	BLUE|blue)
	    echo -n -e "\033[1;34m"
	    ;;	
	GREY|grey)
	    echo -n -e "\033[1;30m"
	    ;;
	PURPLE|purple)
	    echo -n -e "\033[1;35m"
	    ;;
    esac
    
    # Print Argument
    shift
    if [ "$1" = "-n" ]; then
      shift
      echo -n "$*"    
    else
      echo "$*"    
    fi
    
    # Restore Default Color
    echo -n -e $DEFAULT_COLOR
  else

    # Ignore colors silently
    shift
    if [ "$1" = "-n" ]; then
      shift
      echo -n "$*"    
    else
      echo "$*"    
    fi

  fi 
}



# -------------------------------------------------------------------

# Version:	@(#) /etc/init.d/functions 1.01 26-Oct-1993
# Author:	Miquel van Smoorenburg, <miquels@drinkel.nl.mugnet.org>
# Hacked by:    Greg Galloway and Marc Ewing

# Original file derived from Red-Hat
# Modified to work under Bad Penguin by AGX

# The second half of this script is full copyrighted by Antonio GALLO


# First set up a default search path.
#export PATH="/sbin:/usr/sbin:/bin:/usr/bin"

# A function to start a program.
daemon() {
	# Test syntax.
	if [ $# = 0 ]; then
		echo "Usage: daemon {program}"
		return 1
	fi

        # Save basename.
        base=`basename $1`

        # See if it's already running.
        if [ ! "`pidofproc $1`" = "" ] ; then
		echoc RED "$1 is already running !"
		return 0
        fi

	# echo basename of the program.
	# And start it up.
	echo -n " $base "
	$* &
	return $?
}


# A function to stop a program.
killproc() {
	# Test syntax.
	if [ $# = 0 ]; then
		echo "Usage: killproc {program}"
		return 1
	fi

        # Save basename.
        base=`basename $1`

        # Find pid.
        pid="`pidofproc $base`"

        # Kill it.
        if [ ! "$pid" = "" ] ; then
                echo -n " $base "
		kill -15 $pid
		#<BEGIN PARTICULAR>
                pid="`pidofproc $base`"
                if [ ! "$pid" = "" ] ; then
                  kill -9 $pid
		fi
		#<END PARTICULAR>
	else
		echoc YELLOW "Process '$base' does not have any PID !"
	fi

        # Remove pid file if any.
        rm -f /var/run/$base.pid
}



# A function to stop (with 'killall' )a program.
# by AGX
killALL() {
	# Test syntax.
	if [ $# = 0 ]; then
		echo "Usage: killproc {program}"
		return 1
	fi

        # Save basename.
        base=`basename $1`

        # Find pid.
        pid="`pidofproc $base`"

        # Kill it.
        if [ ! "$pid" = "" ] ; then
                echo -n " $base "
                killall $pid
		#<BEGIN PARTICULAR>
                pid="`pidofproc $base`"
                if [ ! "$pid" = "" ] ; then
                  killall -9 $pid
		fi
		#<END PARTICULAR>
	else
		echoc YELLOW "Process '$base' does not have any PID !"
	fi

        # Remove pid file if any.
        rm -f /var/run/$base.pid
}


# A function to send the -HUP signal
killHUP() {
	# Test syntax.
	if [ $# = 0 ]; then
		echo "Usage: killHUP {program}"
		return 1
	fi

        # Save basename.
        base=`basename $1`

        # Find pid.
        pid="`pidofproc $base`"

        # Kill it.
        if [ ! "$pid" = "" ] ; then
                echo -n " $base "
                kill -HUP $pid
	else
		echoc YELLOW "Process does not have any PID !"
	fi
}


# A function to find the pid of a program.
pidofproc() {
	# Test syntax.
	if [ $# = 0 ] ; then
		echo "Usage: pidofproc {program}"
		return 1 ; exit 1
	fi

	# First try "pidof"
	pid="`pidof $1`"
	if [ ! "$pid" = "" ] ; then
	        echo $pid
	        return 0 ; exit 0
	fi

	# Next try "/var/run/*.pid" files
	if [ -f /var/run/$1.pid ] ; then
	        pid=`head -1 /var/run/$1.pid`
	        if [ ! "$pid" = "" ] ; then
	                echo $pid
	                return 0
		else
			echo "No PID file"
	        fi
	fi

	# Finally try to extract it from ps
	ps auxw | awk 'BEGIN { prog=ARGV[1]; ARGC=1 } 
			   { if ((prog == $11) || (("(" prog ")") == $11) ||
			   ((prog ":") == $11)) { print $2 } }' $1
}


# A function to massacre a process
massacre() {
    # Test syntax.
    if [ $# = 0 ] ; then
	echo "Usage: massacre {program}"
	return 1
    fi

    echoc YELLOW "Killing $1 "
    base="`basename $1`"
    pid="`pidofproc $base`"
    if [ "$pid" = "" ]; then
      return 0
      exit 0 
    fi

    echo -n "($pid): "
    COUNT=0
    while [ 0 ]; do
      echo -n "#"
      kill -15 $pid
      REPLY=$?
      if [ $REPLY -ne 0 ]; then
        kill -9 $pid
        REPLY=$?
      fi
      if [ $REPLY -ne 0 ]; then
        kill -11 $pid
      fi
      pid="`pidofproc $base`"
      if [ "$pid" = "" ]; then
        break;
      fi
      sleep 1
    done

    # Remove pid file if any.
    rm -f /var/run/$base.pid
}


# ------------------------------------------------------------
# -------------------- Service Utility -----------------------
# ------------------------------------------------------------
# From this point the license is copyright 1999 of Antonio GALLO
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>
# ------------------------------------------------------------

is-executable-present() {
    [ "$1" = "" ] && return 0
    if [ -x $1 ]; then
      return 0;
    fi
    SBIN=""
    if [ -x /usr/local/sbin/$1 ]; then
      SBIN="/usr/local/sbin/$1"
    elif [ -x /usr/local/bin/$1 ]; then
      SBIN="/usr/local/bin/$1"
    elif [ -x /usr/sbin/$1 ]; then
      SBIN="/usr/sbin/$1"    
    elif [ -x /usr/bin/$1 ]; then
      SBIN="/usr/bin/$1"    
    elif [ -x /sbin/$1 ]; then
      SBIN="/sbin/$1"
    elif [ -x /bin/$1 ]; then
      SBIN="/bin/$1"
    fi
    if [ ! "$SBIN" = "" ]; then
      if [ "$3" = "2" ]; then
        SERVICE_BIN2="$SBIN"
      else
        SERVICE_BIN="$SBIN"
      fi
      return 0
    fi
    # Sorry, not found in path
    [ $RELAXED = 0 ] && ( echoc "RED" "file $1 was not found !" )
    [ -f $2 ] && rm -f $2
    exit 50
}

is-prerequisite-present() {
    [ "$1" = "" ] && return 0
    if [ ! -f /var/lock/subsys/$1 ]; then
      [ $RELAXED = 0 ] && ( echoc RED "prerequisite $1 was not found !" )
      exit 51
    fi
    return 0
}

is-service-configured() {
    [ "$1" = "" ] && return 0
    # Carica il file di configurazione
    if [ -f /etc/sysconfig/$PROFILE/$1 ]; then
      . /etc/sysconfig/$PROFILE/$1
      # Controlla se il servizio e' abilitato
      case $RUNME in
	NONE|NEVER|LOCKED)
          [ $RELAXED -eq 0 ] && echoc YELLOW "This service is locked. Change the start mode into MANUAL"
          exit 53
	  ;;
        # Se RELAXED allora MANUAL "NON DEVE" avviare il servizio
        MANUAL*)
          if [ $RELAXED -eq 1 ]; then
            exit 53
          fi
          ;;
      esac
      return 0
    else
      # Se non presente, prova a lanciare il programma di configurazione
      if [ ! "$2" = "" ]; then
        if [ ! -x "$2" ]; then
          echoc RED "setup/configure program was not found ($2)"
          exit 52
	else
	  [ -d `dirname "$2"` ] && cd `dirname "$2"`
	  exec $2
          exit 52
        fi
      else
        # If there is not a configuration program then lock the service
	echoc RED "Unable to run and configure, the service $1 will not started at boot time"
        echo "RUNME=MANUAL" > /etc/sysconfig/$PROFILE/$1
        exit 53
      fi
      [ $RELAXED = 0 ] && ( echoc YELLOW "$SERVICE_NAME not configured !" )
      exit 53
    fi
}

is-not-daemon-running () {
    if [ -f /var/lock/subsys/$1 ]; then
      if [ $RELAXED -ne 0 ]; then
        exit 60
      fi
      pidof $2 >/dev/null 2>/dev/null
      if [ $? = 0 ]; then
        echoc YELLOW "$1 is already started !"
        exit 60
      fi
    fi
    return 0
}

is-daemon-running () {
    if [ ! -f /var/lock/subsys/$1 ]; then
      if [ $RELAXED -ne 0 ]; then
        exit 61
      fi
      pidof $2 >/dev/null 2>/dev/null
      if [ $? -ne 0 ]; then
        echoc YELLOW "$1 was already stopped !"
        exit 61
      fi
    fi
    return 0
}

daemon-status() {
    #Display Daemon Starting Mode
    daemon-mode $3
    
    # Check lock file
    if [ -f /var/lock/subsys/$1 ]; then
      [ "$2" = "" ] && exit 100
      pidof $2 >/dev/null 2>/dev/null
      if [ $? = 0 ]; then
        exit 100
      else
        exit 200
      fi
    elif [ -f /etc/sysconfig/$PROFILE/$3 ]; then
      RCOD1=101
      RCOD2=201
      case $RUNME in
        NONE|NEVER|LOCKED)
          RCOD1=102
          RCOD2=202
        ;;
      esac
      [ "$2" = "" ] && exit $RCOD1
      pidof $2 >/dev/null 2>/dev/null
      if [ $? -ne 0 ]; then
        exit $RCOD1
      else
        exit $RCOD2
      fi

    else
      [ "$2" = "" ] && exit 102
      pidof $2 >/dev/null 2>/dev/null
      if [ $? -ne 0 ]; then
        exit 102
      else
        exit 202
      fi
    fi
}

daemon-mode() {
    if [ -f /etc/sysconfig/$PROFILE/$1 ]; then
	. /etc/sysconfig/$PROFILE/$1
	case $RUNME in
	    MANUAL*)
		echo -n "(manual) "
		return 1
		;;
	    NONE|NEVER|LOCKED)
		echo -n "(locked) "
		return 2
		;;
	    *)
		echo -n "  (auto) "
		return 0
		;;
	esac
    else
	echo -n "   (n/a) "
	return 3
    fi
}

