#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>

# Event viewer for /var/spool/log/*.log
# 1999-04-27, Version 1.0.0 by AGX
# 1999-10-14, Version 1.2.0 by AGX
# 1999-11-29, Version 1.6.0 by AGX: some fixes


# --- Temp Script ---
TEMPDIR="$HOME/tmp"
[ ! -d $TEMPDIR ] && mkdir -p $TEMPDIR
TEMPSCRIPT=$TEMPDIR/ev-script.$$
TEMPDATA=$TEMPDIR/ev-data.$$
trap 'rm -f $TEMPDATA $TEMPSCRIPT ; exit $USCITA' 0
USCITA=0


# Costruisce l'elenco dei log una sola volta
rm -f $TEMPSCRIPT $TEMPDATA
dialog --infobox "\n     Lettura elenco dei logs ...     \n" 0 0
> $TEMPSCRIPT
for i in /var/log/*.log; do
  if [ -f "$i" ]; then
    CATEGORY="`basename $i .log`"
    FILESIZE="`filesize $i`"
    echo -n "$CATEGORY:$FILESIZE:" >> $TEMPSCRIPT
  fi
done


# Legge i log
while [ 0 ] ; do

  # Ask for a categorie
  IFS=":"
  dialog --title "Log Viewer menu'" --menu "Seleziona una classe di eventi da visualizzare.\n\
Premi CANCEL o ESC per ritornare indietro. \n\n\
                    Classe     Dimensione in byte" \
  20 65 10 `cat $TEMPSCRIPT` 2> $TEMPDATA
  if [ $? -ne 0 ]; then
    break;
  fi


  # Legge il log
  CATEGORY=`cat $TEMPDATA 2>/dev/null`
  FILESIZE=`filesize /var/log/$CATEGORY.log 2>/dev/null`
  if [ $FILESIZE -eq 0 ]; then
    dialog --title "Log View di $CATEGORY" --msgbox "\n     Questo file di log e' vuoto.     \n" 0 0
  else
    dialog --infobox "\n     Apertura del log $CATEGORY ...     \n" 0 0
    dialog --title "Log View di $CATEGORY" --textbox "/var/log/$CATEGORY.log" 0 0
  fi


done
