#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>

# Main controlpanel's script
# 1999-04-27, Version 1.0.0 by AGX
# 1999-10-14, Version 1.2.0 by AGX : Conforming to UP v. 1.6.0 (spec.1.2.0)


VERSION="AGX User's Profiles 1.6.0 for 'Bad Penguin'"
VERSION="$VERSION     [Profile: $PROFILE]"

# --- Temp Script ---
#TEMPSCRIPT=/tmp/tempscript.$PPID
#TEMPDATA=/tmp/tempdata.$PPID
TEMPDIR="$HOME/tmp"
[ ! -d $TEMPDIR ] && mkdir -p $TEMPDIR
TEMPSCRIPT=$TEMPDIR/cp-script.$$
TEMPDATA=$TEMPDIR/cp-data.$$
trap 'rm -f $TEMPDATA $TEMPSCRIPT ; exit $USCITA' 0
USCITA=0


# 1 = Get the Application Path
if [ "$1" = "" ]; then
  APP_PATH="/usr/local/lib/agx-controlpanel"
else
  APP_PATH="$1"
fi

# 2 = Get the Application Name
if [ "$2" = "" ]; then
  APP_NAME="AGX User's Profiles"
else
  APP_NAME="$2"
fi

# Set temporary files
HINTS="Premi ESC o CANCEL per tornare al menu' precedente. Altrimenti premi INVIO sulla scelta preferita."
INSTALLED_DIR="/usr/local/lib/agx-controlpanel/"
CURRENT_DIR="$PWD"
# Main Loop, you can exit from here only when pressing
# the button CANCEL or CTRL+C from the menu'
while [ 0 ]; do

  # Restore Installation directory
  cd $INSTALLED_DIR

  # Build the menu from current APP_PATH
  ITEMCOUNT=0
  > $TEMPSCRIPT
  cd "$APP_PATH"
    for i in *; do
      if [ -d "$i" ]; then
        MENUITEM="`echo $i | cut -b 4-`"
        [ "$MENUITEM" = "" ] && MENUITEM=" "
        echo -n "$MENUITEM::" >> $TEMPSCRIPT
        ITEMCOUNT=$[ ITEMCOUNT + 1 ]
      fi
    done
  cd -

  if [ $ITEMCOUNT -eq 0 ]; then
    dialog --title "$VERSION" --msgbox "\n     Spiacente, ma questo menu' sembra essere non abilitato.     \n" 0 0
  fi
  
  # Read user choice
  MENUDIR=""
  while [ "$MENUDIR" = "" ]; do
    if [ $ITEMCOUNT -gt 14 ]; then
      ITEMCOUNT=14
    fi
    IFS=":"
    dialog --backtitle "$VERSION" --title "$APP_NAME menu'" --menu "$HINTS" $[ ITEMCOUNT + 10 ] 50 $[ ITEMCOUNT + 1] `cat $TEMPSCRIPT` 2> $TEMPDATA
    REPLY=$?
    if [ $REPLY -eq 255 -o $REPLY -eq 1 ]; then
      # Checking CANCEL or CTRL+C is the only way to exit
      rm -f $TEMPSCRIPT $TEMPDATA
      USCITA=0 ; exit 0
    fi
  
    # Get user choice
    MENUCHOICE="`cat $TEMPDATA`"
    if [ "$MENUCHOICE" = "" ]; then
      # User choosed blank, try again ...
      continue
    fi
  
    # This is necessay to validate the Menuchoice with the real name
    # of the directory that have a "XX-" prefixed
    cd $APP_PATH/$MENU_DIR
    for i in * ; do
      if [ -d "$i" ]; then
        MENUITEM="`echo $i | cut -b 4-`"
        if [ ! "$MENUITEM" = "" ]; then
          if [ "$MENUITEM" = "$MENUCHOICE" ]; then
            # You gotta it, break the cycle and run your favourite app
            MENUDIR="$i"
	    # Note that this break exit only from the 'for' cycle
	    # We exit from then 'while..do' cause MENUDIR is not empty
	    break
          fi
        fi
      fi
    done
    cd -
    
    # Launch the Sub Menu or the .rc files
    if [ ! "$MENUDIR" = "" ]; then
      if [ -x "$APP_PATH/$MENUDIR/mainmenu.rc" ]; then
        (
	  cd /usr/local/lib/agx-userprofiles/
          "$APP_PATH/$MENUDIR/mainmenu.rc"
	)
      else
        /usr/local/lib/agx-userprofiles/mainmenu.sh "$APP_PATH/$MENUDIR" "$MENUCHOICE"
      fi
    fi
  done
  #
done
cd "$CURRENT_DIR"
#END

# Thank you Linux guys !!!
